/// <reference types="node" />
/// <reference types="node" />
import * as http from "http";
import { Verb } from "./tsrequest";
import { Nullable, StringDictionary, TSDictionary } from "./types";
import { TSLeafNode, TSNode } from "./tsparser";
import { TSServerLogger } from "./tsserver";
export interface TSServerRequest {
    message: http.IncomingMessage;
    method: Verb;
    url: URL;
    parameters: TSDictionary;
    query: TSDictionary;
    body: Nullable<string | number | boolean | object | Buffer>;
}
export type TSServerResponse = http.ServerResponse;
export type TSEndPointController = (req: TSServerRequest, resp: TSServerResponse) => Promise<void>;
export interface TSEndPoint {
    controller: TSEndPointController;
    query?: {
        [key: string]: TSLeafNode;
    };
    body?: TSNode;
}
export type TSEndpointsDefinition = {
    [key in Verb]?: TSEndPoint | TSEndPointController;
} | TSEndPoint | TSEndPointController;
export declare enum TSServerStartStatus {
    AlreadyRunning = 0,
    HTTP = 1,
    HTTPS = 2
}
export interface TSStaticWebSiteOptions {
    logger?: TSServerLogger;
    managedTypes?: StringDictionary;
    maxCacheSize?: number;
    maxCachedFileSize?: number;
    maxCachedFiles?: number;
    maxBlacklistedFiles?: number;
}
